package de.renew.meta;

import de.renew.net.*;
import de.renew.engine.events.*;
import de.renew.net.event.TokenEvent;
import de.renew.net.event.PlaceEvent;
import de.renew.net.event.PlaceEventListener;
import java.util.Set;
//import de.renew.net.event.PlaceEvent;


public class MetaPlace extends MetaObject implements PlaceEventListener{

	private PlaceInstance _placeInstance;
	private TestPlaceEventListener listener;
	public MetaPlace(){
		super();
		//listener=new TestPlaceEventListener();
		//listener.setMetaPlace(this);
	
	}
	public MetaPlace(Net net, PlaceInstance placeInstance){
		_placeInstance = placeInstance;
		/*
		attach(place);
		registerEvent();
		*/
		
	}
	public PlaceInstance getPlaceInstance(){
		return _placeInstance;
	}
	
	/* */
	public void attach(String  placeName,NetInstance netInstance){
		try{
			
		
		PlaceInstance placeInstance=netInstance.getPlaceInstanceWithName(placeName);
		
		if(placeInstance!=null){
			super.attach(placeName,netInstance);
			placeInstance.addPlaceEventListener(this);
			_placeInstance=placeInstance;
			}
		}catch(Exception e){
			System.out.println("metaplace.attach "+e.toString());
		}
			
	}
	public void detach(String  placeName,NetInstance netInstance){
		super.detach(placeName,netInstance);
		PlaceInstance placeInstance=netInstance.getPlaceInstanceWithName(placeName);
		placeInstance.removePlaceEventListener(this);
		_placeInstance=null;
	}
	public void eventStart(SimulationEvent event){
	/* user defined codes, get marking of place,
	* add tokens to place or remove tokens from place etc
	*/
	}
	public void eventCompleted(SimulationEvent event){
	/* user defined codes, get marking of place,
	* add tokens to place or remove tokens from place etc
	*/
	}
	
	public Object base(){
	return _placeInstance;
	}
	// manipulate tokens in the place
	private Object[] Marking(){
		return null;
	}
	private void addTokens(Object[] tokens){
		
	}
	
	public void insertToken(Object token){
		_placeInstance.lock.lock();
		try{
		_placeInstance.insertToken(token);
		}catch(Exception e){
			System.out.println("MetaPlace.insertToken "+e.toString());
		}finally{
			_placeInstance.lock.unlock();
		}
	}
	/*
	private void RemoveTokens(Condition cond){
	
	}
	*/

	 public void markingChanged(PlaceEvent pe){
    		//System.out.println("markingChanged "+pe.toString());
		call("markingChanged");
   	 }

    /** This event occurs when a single token (contained in the
     *  event object) is put into the corresponding PlaceInstance.
     */
    	public void tokenAdded(TokenEvent te){
    
   		// System.out.println("tokenAdded "+te.toString());
		 call("tokenAdded");
    	}

    /** This event occurs when a single token (contained in the
     *  event object) is removed from the corresponding PlaceInstance.
     */
    public void tokenRemoved(TokenEvent te){
    		 //System.out.println("tokenRemoved "+te.toString());
		call("tokenRemoved");
    	}

    /** This event occurs when a token (contained in the
     *  event object) is tested within the corresponding PlaceInstance.
     */
    public void tokenTested(TokenEvent te){
    		 //System.out.println("tokenTested "+te.toString());
		call("tokenTested");
    	}

    /** This event occurs when a token (contained in the
     *  event object) is untested within the corresponding PlaceInstance.
     */
    public void tokenUntested(TokenEvent te){
    		//System.out.println("tokenUntested "+te.toString());
		call("tokenUntested");
    	}
    public boolean wantSynchronousNotification(){
	return true;
    }
	public String getName(){
		return _placeInstance.getPlace().getName();
	}
}