/*
	added by david

	for testing load a class into the system and run some functions
*/
package de.renew.meta;

import de.renew.net.event.*;
import de.renew.util.*;
import de.renew.engine.common.SimulatorEventLogger;	
import de.renew.net.Place;
import de.renew.net.Transition;
import de.renew.net.TransitionInstance;
import de.renew.net.PlaceInstance;
import de.renew.formalism.java.*;
import de.renew.net.arc.Arc;
import de.renew.net.FIFOPlaceInstance;
import de.renew.net.MultisetPlaceInstance;
import de.renew.net.NetInstance;
import de.renew.application.SimulatorPlugin;
import de.renew.engine.searchqueue.SearchQueue;
import de.renew.net.TransitionInscription;

import java.lang.*;
import java.lang.reflect.*;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Hashtable;
import java.util.Iterator;
import java.util.List;
import java.util.HashMap;


public class  MetaPlugin {

	public static final int PLACE=0;
	public static final int TRANSITION=1;

	public static org.apache.log4j.Logger logger = org.apache.log4j.Logger
                                                   .getLogger(MetaPlugin.class);
	public static NetInstance _netInstance;

	public static HashMap instanceLookup=new HashMap();//<String ,MetaObject>
	public static void init(NetInstance netInstance)
	{
		//this function can only be called once for each simulation.
		instanceLookup=new HashMap();
		_netInstance=netInstance;
		SimulatorEventLogger.log("in MetaPlugin.init()");
		logger.warn("in MetaPlugin.init()");
		System.out.println("in MetaPlugin.init()");
		try{
			/*
			Class userPlugin=ClassSource.classForName("UserPlugin");
			Class<?> parameterTypes[]=new Class<?>[1];
			
			parameterTypes[0]=NetInstance.class;
			Method initMethod=userPlugin.getMethod("init",parameterTypes);	
			initMethod.invoke(null,netInstance);
			*/
			Class userPlugin=ClassSource.classForName("UserScript");
			Class<?> parameterTypes[]=new Class<?>[0];

			Method initMethod=userPlugin.getMethod("setup",parameterTypes);	
			initMethod.invoke(null,new Object[0]);
			System.out.println("MetaPlugin.init finish succefully");
			logger.warn("MetaPlugin.init finish succefully");
			SimulatorEventLogger.log("MetaPlugin.init finish succefully");
			}catch(Exception e)
				{
					SimulatorEventLogger.log("Exception happen "+e.toString());
					logger.warn("Exception happen "+e.toString());
					System.out.println("Exception happen "+e.toString());
				}
		
		
	}

	public static NetInstance getNetInstance(){
		return _netInstance;
	}
	public static void addFIFOPlaceInstance(String name){
		Place place=new Place(getNetInstance().getNet(),name);
		//we only can make netinstance without initial marking, user can add tokens afterwards
		try{
		PlaceInstance placeInstance =new FIFOPlaceInstance(getNetInstance(),place,false);
		getNetInstance().addPlaceInstance(placeInstance);
		}catch(Exception e){
			System.out.println("MetaPlugin.addFIFOPlaceInstance "+e.toString());
		}
	}
	public static void addMultisetPlaceInstance(String name){
		Place place=new Place(getNetInstance().getNet(),name);
		//we only can make netinstance without initial marking, user can add tokens afterwards
		try{
		PlaceInstance placeInstance =new MultisetPlaceInstance(getNetInstance(),place,false);
		getNetInstance().addPlaceInstance(placeInstance);
		}catch(Exception e){
			System.out.println("MetaPlugin.addFIFOPlaceInstance "+e.toString());
		}
	}

	public static void addPlaceInstance(String name){
		try{
		Place place=new Place(getNetInstance().getNet(),name);
		PlaceInstance placeInstance=place.makeInstance(getNetInstance(), false);
		getNetInstance().addPlaceInstance(placeInstance);
		}catch(Exception e){
			System.out.println("MetaPlugin.addPlaceInstance "+e.toString());
		}
		
		/*
		Place place=new Place(getNetInstance().getNet(),name);
		//we only can make netinstance without initial marking, user can add tokens afterwards
		PlaceInstance placeInstance =new PlaceInstance(getNetInstance(),place,false);
		getNetInstance().addPlaceInstance(placeInstance);
		*/
	}

	

	public static void addTransitionInstance(String name){
		Transition transition=new Transition(getNetInstance().getNet(),name);
		TransitionInstance transitionInstance=new TransitionInstance(getNetInstance(),transition);
		getNetInstance().addTransitionInstance(transitionInstance);
		transitionInstance.createConfirmation();
	}

	public static void addArc(String placeInstance, String transitionInstance, int arcType){
		System.out.println("addArc "+ placeInstance +" "+ transitionInstance +arcType);
		addArc(getPlaceInstance(placeInstance),getTransitionInstance(transitionInstance),arcType);
	}

	public static void addArc(PlaceInstance placeInstance,TransitionInstance transitionInstance,int arcType){
		Class PlaceType=Types.UNTYPED;
		//create a simple arc factory don't allow time insription, and the type is Arc.out
		
		SimpleArcFactory factory=new SimpleArcFactory(arcType,true);
		//compile the a simple arc with no arc incription
		//PlaceType is set to be UNTYPED
		try{
		SingleJavaNetCompiler compiler=new SingleJavaNetCompiler(true,true,true);
		factory.emptyArcCheck();
		//Collection emptyArcExpression=compiler.makeEmptyArcExpressions();
		
		compiler.compileSingleArcInscription(compiler.makeEmptyArcExpressions(),
                                            PlaceType, factory,
                                            placeInstance.getPlace(), transitionInstance.getTransition(),
                                            false);
		placeInstance.getPlace().addArc((Arc)(getArc(transitionInstance.getTransition(),placeInstance.getPlace(),arcType)));
		}
		catch(Exception e){
			System.out.println("MetaPlugin.addArc	"+e.toString());
		}
                                           
	}

	public static TransitionInscription getArc(Transition transition,Place place ,int arcType){
		return transition.getArc(place,arcType);
	}

	public synchronized static void removeArc(PlaceInstance placeInstance,TransitionInstance transitionInstance,int arcType){
		//SimulatorPlugin.getCurrent().getCurrentEnvironment().getSimulator().stopRun();
		
		boolean result=transitionInstance.getTransition().removeArc( placeInstance,  arcType);
		if(result==false){
			logger.warn("removeArc failed");
			System.out.println("removeArc failed");
		}
		
		System.out.println("in MetaPlugin.removeArc");
		//SimulatorPlugin.getCurrent().getCurrentEnvironment().getSimulator().startRun();
	}
	public synchronized static void  removeArc(String placeInstance,String transitionInstance,int arcType){
		System.out.println("removeArc "+ placeInstance +" "+ transitionInstance +arcType);
		removeArc(getPlaceInstance(placeInstance),getTransitionInstance(transitionInstance),arcType);
	}
	
	//this is a gentle way of removing Place
	public static void removePlace(PlaceInstance placeInstance){
		//it is required that before remove the place, the related arcs have been removed.
		
		if(checkPlaceArcs(placeInstance)){
			(_netInstance.getNet()).remove((Place)(placeInstance.getPlace()));
			_netInstance.remove(placeInstance.getPlace());
		}else{
			System.out.println("MetaPlugin.removePlace failed because related arcs exist");
		}
	}
	//this is a gentle way of removing Transition
	public static void removeTransition(TransitionInstance transitionInstance){
		//it is required that before remove the transition, the related arcs have been removed.
		if(checkTransitionArcs(transitionInstance)){
			//remove the transition from Net ,NetInstance, SearchQueue
			(_netInstance.getNet()).remove((Transition)(transitionInstance.getTransition()));
			_netInstance.remove(transitionInstance.getTransition());
			SearchQueue.exclude(transitionInstance);
		}else{
			System.out.println("MetaPlugin.removeTransition failed because related arcs exist");
		}
	}

	public static boolean checkPlaceArcs(PlaceInstance placeInstance){
		Place place=placeInstance.getPlace();
		return place.isArcsEmpty();
	}

	public static boolean checkTransitionArcs(TransitionInstance transitionInstance){
		Transition transition =transitionInstance.getTransition();
		return transition.checkArcs();
	}
	public static void put(String name,MetaObject metaObject){
		instanceLookup.put(name,metaObject);
	}

	public static MetaObject get(String name){
		return (MetaObject)(instanceLookup.get(name));
	}
	public static void remove(String name){
		instanceLookup.remove(name);
	}
	public static void register(String event,String function,String name, int type){
		MetaObject metaObject=getMetaObject(name, type);
		if(metaObject==null){
			//TODO warning
		}else{
			metaObject.register( event,  function);
		}
		
	}
	public static void unRegister(String event,String name, int type){
		MetaObject metaObject=getMetaObject(name, type);
		if(metaObject==null){
			//TODO warning
		}else{
			metaObject.unRegister( event);
		}
	}
	public static MetaObject getMetaObject(String name,int type){
		/**
			if we have attached an Metaobject to it, then find the metaObject, if not, create a new one.
		*/
		//System.out.println("getMetaObject "+name+" "+type);
		MetaObject result=null;
		 result= (MetaObject)(instanceLookup.get(name));

		if (result==null){
			
			//System.out.println("can't find the metaObject create one");
			switch(type){
				case PLACE:

					MetaPlace metaPlace=new MetaPlace();
					metaPlace.attach(name,_netInstance);
					if(metaPlace.getPlaceInstance()==null){
						return null;
						//System.out.println("in MetaPlugin.getMetaObject  placeintance is null");
					}
					
					return metaPlace;
					
				case TRANSITION:
					MetaTransition metaTransition=new MetaTransition();
					metaTransition.attach(name,_netInstance);
					if(metaTransition.getTransitionInstance()==null)
						return null;
					return metaTransition;
				default:
					System.out.println("bad type in MetaPlugin.getMetaObject");
					return null;
					
			}
			
		}else{
			return result;
		}
	}
	public static MetaPlace getMetaPlace(String name){
		
		MetaPlace temp=(MetaPlace)(getMetaObject( name, PLACE));
		if(temp.getPlaceInstance()==null){
			System.out.println("MetaPlugin.getMetaPlace placeinstance is null");
		}
		return temp;
	}
	public static MetaTransition getMetaTransition(String name){
		return (MetaTransition)(getMetaObject( name, TRANSITION));
	}
	public static void removeTransitionF(TransitionInstance transitionInstance){
		(_netInstance.getNet()).remove((Transition)(transitionInstance.getTransition()));
		_netInstance.remove(transitionInstance.getTransition());
		SearchQueue.exclude(transitionInstance);
		instanceLookup.remove(transitionInstance.getTransition().getName());
	}

	public static void removeTransitionF(String name){
		removeTransitionF(getTransitionInstance(name));
	}

	public static void removePlaceF(String name){
		removePlaceF(getPlaceInstance(name));
	}

	public static void removePlaceF(PlaceInstance placeInstance){
		try{
			
		(_netInstance.getNet()).remove((Place)(placeInstance.getPlace()));
		_netInstance.remove(placeInstance.getPlace());
		instanceLookup.remove(placeInstance.getPlace().getName());
		}catch(Exception e){
		System.out.println("metaplugin.removeplacef "+ e.toString());
			}
	}
	public static TransitionInstance getTransitionInstance(String name){
		return _netInstance.getTransitionInstanceWithName( name);
	}
	public static PlaceInstance getPlaceInstance(String name){
		return _netInstance.getPlaceInstanceWithName( name);
	}

	public static boolean exist(String name){
		return (instanceLookup.get(name)==null)?false:true;
	}

	
	
}