package de.renew.meta;

import de.renew.net.*;
import de.renew.engine.events.*;
import de.renew.net.event.TransitionEventListener;
import de.renew.net.event.FiringEvent;

public class MetaTransition extends MetaObject implements TransitionEventListener{
	private Transition _transition;
	private TransitionInstance _transitionInstance;
	public MetaTransition(Net net, Transition transition){
		_transition = transition;
		/*
		attach(transition);
		registerEvent(...);
		*/
	}

	public MetaTransition(){
		super();
	}
	public void eventStart(SimulationEvent event){
		/* user defined codes,
		* maybe reflect stuff concerning guard or action
		*/
	}
	public void eventCompleted(SimulationEvent event){
	/* user defined codes,
	* maybe reflect stuff concerning guard or action
	*/
	}
	public TransitionInstance getTransitionInstance(){
		return _transitionInstance;
	}
	public Object base(){
		return _transition;
	}
	/*
	* private methods to reflect stuff concerning guard or
	* action follows.
	* since guard and action can be complex expressions,
	* therefore a lot of metaobject protocol used by reflective
	* model in languages can be used here
	*/

	public void attach(String  transitionName,NetInstance netInstance){
		
		TransitionInstance transitionInstace=netInstance.getTransitionInstanceWithName(transitionName);
		transitionInstace.addTransitionEventListener(this);
		_transitionInstance=transitionInstace;
		if(transitionInstace!=null)
			super.attach(transitionName,netInstance);
			
	}
	public void detach(String  transitionName,NetInstance netInstance){
		super.detach(transitionName,netInstance);
		TransitionInstance transitionInstace=netInstance.getTransitionInstanceWithName(transitionName);
		transitionInstace.removeTransitionEventListener(this);
		_transitionInstance=null;
	}

	public void firingStarted(FiringEvent fe){
		//System.out.println(getName()+" "+ fe.toString());
		call("firingStarted");
	 }

   	 public void firingComplete(FiringEvent fe){
	 	//System.out.println(getName()+" "+ fe.toString());
	 	System.out.println("++++++++++++++++ "+_transitionInstance.getTransition().getName()+"++++++++++++++++++++++");
		call("firingComplete");
   	 }

	 public boolean wantSynchronousNotification(){
	 	return true;
	 }
	 public String getName(){
	 	return _transitionInstance.getTransition().getName();
	 }
}