import java.lang.*;
import java.util.Set;
import java.util.HashSet;
import java.util.HashMap;
import java.util.Random;
import de.renew.meta.*;
import de.renew.net.arc.*;
import de.renew.net.Transition;
import de.renew.unify.Tuple;
import java.util.Iterator;
/**
	this is the meta code for hurried phils
	in this file we change the structure and the base level is in charge of the functional part
*/
public class UserScript extends MetaPlugin{

	//folks are  placed on the right side of philosophers

	//the number of the philosophers
	public static int amount;
	//keep a set of unseated philosophers
	public static Set numSet;
	public static HashMap left;
	public static HashMap right;
	public static void setup(){
		
		numSet=new HashSet();
		left=new HashMap();
		right=new HashMap();
		left.put("1","2");
		left.put("2","1");
		right.put("1","2");
		right.put("2","1");
		register("firingComplete", "chase_away", "chase_away2", TRANSITION);
		register("firingComplete", "chase_away", "chase_away1", TRANSITION);
		register("firingComplete","invite","invite1",TRANSITION);
		register("firingComplete","invite","invite2",TRANSITION);

		getMetaObject("invite1", TRANSITION);
		getMetaObject("chase_away1",  TRANSITION);
		getMetaObject("think1",  TRANSITION);
		getMetaObject("stop_think1",  TRANSITION);
		getMetaObject("take_fk1",  TRANSITION);
		getMetaObject("release_fks1",  TRANSITION);

		getMetaObject("invite2", TRANSITION);
		getMetaObject("chase_away2",  TRANSITION);
		getMetaObject("think2",  TRANSITION);
		getMetaObject("stop_think2",  TRANSITION);
		getMetaObject("take_fk2",  TRANSITION);
		getMetaObject("release_fks2",  TRANSITION);
		
		try{
		register("firingComplete","take_fk","take_fk1",TRANSITION);
		register("firingComplete","take_fk","take_fk2",TRANSITION);
		}catch(Exception e){
			System.out.println("UserScript.setup "+e.toString());
		}
		
	}
	public static void chase_away(MetaObject metaObject){
		//add the chased away philosopher to the set

		try{
		Transition transition=((MetaTransition)metaObject).getTransitionInstance().getTransition();
		String name=transition.getName();
		String mynum=name.replace("chase_away","");
		Random random=new Random();
		String num;
		if(left.get(mynum).equals(mynum))//only one phils left, he can't chase away himself
			return ;

		if(random.nextFloat()>0.5){//chase the left one
			System.out.println("chase the left one");
			num=(String)(left.get(mynum));
			left.put(mynum,left.get(num));
			right.put(left.get(num),mynum);
			String leftnum=(String)(left.get(mynum));

			removeArc("fk"+num,"take_fk"+mynum,Arc.in);
			

			removeArc("fk"+num,"release_fks"+mynum,Arc.out);
			if(numSet.size()>0){
			addArc("fk"+leftnum,"take_fk"+mynum,Arc.in);
			addArc("fk"+leftnum,"release_fks"+mynum,Arc.out);
			}
			
		}else{//chase the right one
			System.out.println("chase the right one");
			num=(String)(right.get(mynum));
			right.put(mynum,right.get(num));
			left.put(right.get(num),mynum);
			String rightnum=(String)(right.get(mynum));
			
			removeArc("fk"+num,"take_fk"+rightnum,Arc.in);
			removeArc("fk"+num,"release_fks"+rightnum,Arc.out);
			if(numSet.size()>0){
			addArc("fk"+mynum,"take_fk"+rightnum,Arc.in);
			addArc("fk"+mynum,"release_fks"+rightnum,Arc.out);
			}

		}
		System.out.println(mynum+" chase away "+num);
		left.remove(num);
		right.remove(num);
		numSet.add(num);
		MetaPlace ph=getMetaPlace("ph"+num);
		MetaPlace thinking_ph=getMetaPlace("thinking_ph"+num);
		MetaPlace eat=getMetaPlace("eat"+num);
		System.out.println("befor get meta obejct  " +exist("fk"+num));
		MetaPlace fk=getMetaPlace("fk"+num);
		MetaTransition invite=getMetaTransition("invite"+num);
		MetaTransition think=getMetaTransition("think"+num);
		MetaTransition chase_away=getMetaTransition("chase_away"+num);
		MetaTransition take_fk=getMetaTransition("take_fk"+num);
		MetaTransition release_fk=getMetaTransition("release_fks"+num);
		MetaTransition stop_think=getMetaTransition("stop_think"+num);
		removeTransitionF(invite.getTransitionInstance());
		removeTransitionF(think.getTransitionInstance());
		removeTransitionF(chase_away.getTransitionInstance());
		removeTransitionF(take_fk.getTransitionInstance());
		removeTransitionF(release_fk.getTransitionInstance());
		removeTransitionF(stop_think.getTransitionInstance());
		if(fk==null)
			System.out.println("fk is null");
		if(fk.getPlaceInstance()==null)
			System.out.println("placeinstance is null");
		removePlaceF(ph.getPlaceInstance());
		removePlaceF(thinking_ph.getPlaceInstance());
		removePlaceF(eat.getPlaceInstance());
		removePlaceF(fk.getPlaceInstance());
		
		state("after chase_away");
			}catch(Exception e){
				System.out.println("UserScript.chase_away "+e.toString());
				}
	}
	public static void invite(MetaObject metaObject){
		//pick a num from the set randomly
		//decide the invited ph to sit left or right

		try{
		Transition transition=((MetaTransition)metaObject).getTransitionInstance().getTransition();
		String name=transition.getName();
		String mynum=name.replace("invite","");
		
		Random random=new Random();
		Iterator iterator=numSet.iterator();
		String num=new String();
		if(iterator.hasNext()){
			num=(String)(iterator.next());
			iterator.remove();
			System.out.println(mynum+ " invite "+num);
		}else{
			return;
		}
		String leftnum,rightnum;
		if(random.nextFloat()>0.5){//sit left
			leftnum=(String)(left.get(mynum));
			rightnum=mynum;
			
			right.put(num,mynum);
			left.put(num,left.get(mynum));
			right.put(left.get(mynum),num);
			left.put(mynum,num);
			
		}else{//sit right
			rightnum=(String)(right.get(mynum));
			leftnum=mynum;
			left.put(num,mynum);
			right.put(num,right.get(mynum));
			left.put(right.get(mynum),num);
			right.put(mynum,num);
		}
		addPlaceInstance("ph"+num);
		addPlaceInstance("thinking_ph"+num);
		addPlaceInstance("eat"+num);
		addPlaceInstance("fk"+num);
		addTransitionInstance("invite"+num);
		addTransitionInstance("think"+num);
		addTransitionInstance("chase_away"+num);
		addTransitionInstance("take_fk"+num);
		addTransitionInstance("release_fks"+num);
		addTransitionInstance("stop_think"+num);

		addArc("ph"+num, "invite"+num, Arc.both);
		addArc("ph"+num,"chase_away"+num,Arc.both);
		addArc("ph"+num,"think"+num,Arc.in);
		addArc("thinking_ph"+num,"think"+num,Arc.out);
		addArc("thinking_ph"+num,"take_fk"+num,Arc.in);
		addArc("fk"+num,"take_fk"+num,Arc.in);
		addArc("eat"+num,"take_fk"+num,Arc.out);
		addArc("eat"+num,"release_fks"+num,Arc.in);
		addArc("ph"+num,"release_fks"+num,Arc.out);


		addArc("ph"+num,"stop_think"+num,Arc.out);
		addArc("thinking_ph"+num,"stop_think"+num,Arc.in);

		if(numSet.size()>-1){//should be 0
			System.out.println("----------------"+numSet.size());

		removeArc("fk"+leftnum, "take_fk"+rightnum,Arc.in);
		removeArc("fk"+leftnum,"release_fks"+rightnum,Arc.out);
		}

		addArc("fk"+num,"take_fk"+rightnum,Arc.in);
		addArc("fk"+leftnum,"take_fk"+num,Arc.in);
		addArc("fk"+num,"release_fks"+rightnum,Arc.out);
		addArc("fk"+leftnum,"release_fks"+num,Arc.out);


		getMetaPlace("ph"+num).insertToken(new Tuple(0));
		MetaPlace temp=getMetaPlace("fk"+num);
	
		temp.insertToken(new Tuple(0));

		
		getMetaObject("invite"+num, TRANSITION);
		getMetaObject("chase_away"+num,  TRANSITION);
		getMetaObject("think"+num,  TRANSITION);
		getMetaObject("stop_think"+num,  TRANSITION);
		getMetaObject("take_fk"+num,  TRANSITION);
		getMetaObject("release_fks"+num,  TRANSITION);
		


		register("firingComplete","invite","invite"+num,TRANSITION);
		register("firingComplete","chase_away","chase_away"+num,TRANSITION);
		register("firingComplete","take_fk","take_fk"+num,TRANSITION);

		state("after invite");
		
		}catch(Exception e){
				System.out.println("UserScript.invite "+e.toString());
				}
		
	}

	public static void state(String message){
		
		System.out.println("=============== "+message);
		try{
		System.out.println("************* fk1 contains "+
		getMetaPlace("fk1").getPlaceInstance().getNumberOfTokens());
		}catch(Exception e){
			System.out.println("UserScript.state "+e.toString());
		}
		try{
		System.out.println("************* fk2 contains "+
		getMetaPlace("fk2").getPlaceInstance().getNumberOfTokens());
		}catch(Exception e){
			System.out.println("UserScript.state "+e.toString());
		}
		
		
	}

	public static void take_fk(MetaObject metaObject){
		try{
		System.out.println("__________________ "+((MetaTransition)metaObject).getName()+"is eating");
		}catch(Exception e){
			System.out.println("UserScript.eat "+e.toString());
		}
	}
	
}

